You are viewing a plain text version of this content. The canonical link for it is here.
Posted to commits@allura.apache.org by br...@apache.org on 2013/03/28 17:57:33 UTC

[04/42] git commit: [5453] Adding tests and fixing errors related to commit stats

[5453] Adding tests and fixing errors related to commit stats


Project: http://git-wip-us.apache.org/repos/asf/incubator-allura/repo
Commit: http://git-wip-us.apache.org/repos/asf/incubator-allura/commit/bb12ad35
Tree: http://git-wip-us.apache.org/repos/asf/incubator-allura/tree/bb12ad35
Diff: http://git-wip-us.apache.org/repos/asf/incubator-allura/diff/bb12ad35

Branch: refs/heads/db/5453
Commit: bb12ad353f33098dd9448763f7e609ca0020f34a
Parents: a133da1
Author: Stefano Invernizzi <st...@apache.org>
Authored: Sat Jan 12 18:37:26 2013 +0100
Committer: Dave Brondsema <db...@slashdotmedia.com>
Committed: Thu Mar 28 16:53:30 2013 +0000

----------------------------------------------------------------------
 ForgeUserStats/forgeuserstats/model/stats.py       |   22 ++-
 .../forgeuserstats/tests/data/testgit.git/HEAD     |    1 +
 .../forgeuserstats/tests/data/testgit.git/config   |    4 +
 .../tests/data/testgit.git/description             |    1 +
 .../data/testgit.git/hooks/applypatch-msg.sample   |   15 ++
 .../tests/data/testgit.git/hooks/commit-msg.sample |   24 ++
 .../data/testgit.git/hooks/post-commit.sample      |    8 +
 .../tests/data/testgit.git/hooks/post-receive      |    1 +
 .../data/testgit.git/hooks/post-receive.sample     |   15 ++
 .../data/testgit.git/hooks/post-update.sample      |    8 +
 .../data/testgit.git/hooks/pre-applypatch.sample   |   14 ++
 .../tests/data/testgit.git/hooks/pre-commit.sample |   46 ++++
 .../tests/data/testgit.git/hooks/pre-rebase.sample |  169 +++++++++++++++
 .../testgit.git/hooks/prepare-commit-msg.sample    |   36 +++
 .../tests/data/testgit.git/hooks/update            |    1 +
 .../tests/data/testgit.git/hooks/update.sample     |  128 +++++++++++
 .../tests/data/testgit.git/info/exclude            |    6 +
 .../0d/666fc313e6f4829e8d4446d4529394f8e464a9      |  Bin 0 -> 29 bytes
 .../0f/419b54b956f4a849a689105216282f1a4c749a      |  Bin 0 -> 51 bytes
 .../1e/146e67985dcd71c74de79613719bef7bddca4a      |  Bin 0 -> 164 bytes
 .../43/80f66cf5cbd858b73156681d665593ec80a58d      |  Bin 0 -> 43 bytes
 .../4b/825dc642cb6eb9a060e54bf8d69288fbee4904      |  Bin 0 -> 15 bytes
 .../6a/45885ae7347f1cac5103b0050cc1be6a1496c8      |  Bin 0 -> 158 bytes
 .../6d/2ce67bdd55ae2c2ac72cbc879ed7c67ecc9786      |  Bin 0 -> 43 bytes
 .../8c/3c7fbcd903744b20fd7567a1fcefa99133b5bc      |  Bin 0 -> 53 bytes
 .../9a/7df788cf800241e3bb5a849c8870f2f8259d98      |  Bin 0 -> 129 bytes
 .../be/00c63250248c284b842deee5d8fb0b8132acab      |  Bin 0 -> 42 bytes
 .../d7/c40db3ffe2b87e96b94c280a67265c8de7a4ad      |  Bin 0 -> 51 bytes
 .../df/30427c488aeab84b2352bdf88a3b19223f9d7a      |    2 +
 .../e5/6a4d15295d3754310f114c86d93645308110ad      |  Bin 0 -> 43 bytes
 .../e9/65047ad7c57865823c7d992b1d046ea66edf78      |  Bin 0 -> 21 bytes
 .../tests/data/testgit.git/refs/heads/master       |    1 +
 ForgeUserStats/forgeuserstats/tests/test_stats.py  |   42 ++++-
 ForgeUserStats/test.ini                            |   54 +++++
 34 files changed, 589 insertions(+), 9 deletions(-)
----------------------------------------------------------------------


http://git-wip-us.apache.org/repos/asf/incubator-allura/blob/bb12ad35/ForgeUserStats/forgeuserstats/model/stats.py
----------------------------------------------------------------------
diff --git a/ForgeUserStats/forgeuserstats/model/stats.py b/ForgeUserStats/forgeuserstats/model/stats.py
index 0dcf5af..2f5e1b9 100644
--- a/ForgeUserStats/forgeuserstats/model/stats.py
+++ b/ForgeUserStats/forgeuserstats/model/stats.py
@@ -475,16 +475,19 @@ class UserStats(MappedClass):
         self.checkOldArtifacts()
 
     def addCommit(self, newcommit, project):
-        def _addCommitData(stats, topics, languages, newblob, oldblob = None):
+        def _computeLines(newblob, oldblob = None):
             if oldblob:
                 listold = list(oldblob)
             else:
                 listold = []
-            listnew = list(newblob)
+            if newblob:
+                listnew = list(newblob)
+            else:
+                listnew = []
 
             if oldblob is None:
                 lines = len(listnew)
-            elif newblob.has_html_view:
+            elif newblob and newblob.has_html_view:
                 diff = difflib.unified_diff(
                     listold, listnew,
                     ('old' + oldblob.path()).encode('utf-8'),
@@ -492,7 +495,9 @@ class UserStats(MappedClass):
                 lines = len([l for l in diff if len(l) > 0 and l[0] == '+'])-1
             else:
                 lines = 0
-            
+            return lines
+
+        def _addCommitData(stats, topics, languages, lines):          
             lt = topics + [None]
             ll = languages + [None]
             for t in lt:
@@ -518,7 +523,6 @@ class UserStats(MappedClass):
                     else:
                         stats.general[i]['commits'][j].lines += lines
                         stats.general[i]['commits'][j].number += 1
-            return lines
 
         topics = [t for t in project.trove_topic if t]
         languages = [l for l in project.trove_language if l]
@@ -532,16 +536,18 @@ class UserStats(MappedClass):
         for changed in d.changed:
             newblob = newcommit.tree.get_blob_by_path(changed)
             oldblob = oldcommit.tree.get_blob_by_path(changed)
-            totlines+=_addCommitData(self, topics, languages, newblob, oldblob)
+            totlines+=_computeLines(newblob, oldblob)
 
         for copied in d.copied:
             newblob = newcommit.tree.get_blob_by_path(copied['new'])
             oldblob = oldcommit.tree.get_blob_by_path(copied['old'])
-            totlines+=_addCommitData(self, topics, languages, newblob, oldblob)
+            totlines+=_computeLines(newblob, oldblob)
 
         for added in d.added:
             newblob = newcommit.tree.get_blob_by_path(added)
-            totlines+=_addCommitData(self, topics, languages, newblob)
+            totlines+=_computeLines(newblob)
+
+        _addCommitData(self, topics, languages, totlines)
 
         self.lastmonth.commits.append(dict(
             datetime=now, 

http://git-wip-us.apache.org/repos/asf/incubator-allura/blob/bb12ad35/ForgeUserStats/forgeuserstats/tests/data/testgit.git/HEAD
----------------------------------------------------------------------
diff --git a/ForgeUserStats/forgeuserstats/tests/data/testgit.git/HEAD b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/HEAD
new file mode 100644
index 0000000..cb089cd
--- /dev/null
+++ b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/HEAD
@@ -0,0 +1 @@
+ref: refs/heads/master

http://git-wip-us.apache.org/repos/asf/incubator-allura/blob/bb12ad35/ForgeUserStats/forgeuserstats/tests/data/testgit.git/config
----------------------------------------------------------------------
diff --git a/ForgeUserStats/forgeuserstats/tests/data/testgit.git/config b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/config
new file mode 100644
index 0000000..07d359d
--- /dev/null
+++ b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/config
@@ -0,0 +1,4 @@
+[core]
+	repositoryformatversion = 0
+	filemode = true
+	bare = true

http://git-wip-us.apache.org/repos/asf/incubator-allura/blob/bb12ad35/ForgeUserStats/forgeuserstats/tests/data/testgit.git/description
----------------------------------------------------------------------
diff --git a/ForgeUserStats/forgeuserstats/tests/data/testgit.git/description b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/description
new file mode 100644
index 0000000..498b267
--- /dev/null
+++ b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/description
@@ -0,0 +1 @@
+Unnamed repository; edit this file 'description' to name the repository.

http://git-wip-us.apache.org/repos/asf/incubator-allura/blob/bb12ad35/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/applypatch-msg.sample
----------------------------------------------------------------------
diff --git a/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/applypatch-msg.sample b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/applypatch-msg.sample
new file mode 100755
index 0000000..8b2a2fe
--- /dev/null
+++ b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/applypatch-msg.sample
@@ -0,0 +1,15 @@
+#!/bin/sh
+#
+# An example hook script to check the commit log message taken by
+# applypatch from an e-mail message.
+#
+# The hook should exit with non-zero status after issuing an
+# appropriate message if it wants to stop the commit.  The hook is
+# allowed to edit the commit message file.
+#
+# To enable this hook, rename this file to "applypatch-msg".
+
+. git-sh-setup
+test -x "$GIT_DIR/hooks/commit-msg" &&
+	exec "$GIT_DIR/hooks/commit-msg" ${1+"$@"}
+:

http://git-wip-us.apache.org/repos/asf/incubator-allura/blob/bb12ad35/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/commit-msg.sample
----------------------------------------------------------------------
diff --git a/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/commit-msg.sample b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/commit-msg.sample
new file mode 100755
index 0000000..6ef1d29
--- /dev/null
+++ b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/commit-msg.sample
@@ -0,0 +1,24 @@
+#!/bin/sh
+#
+# An example hook script to check the commit log message.
+# Called by git-commit with one argument, the name of the file
+# that has the commit message.  The hook should exit with non-zero
+# status after issuing an appropriate message if it wants to stop the
+# commit.  The hook is allowed to edit the commit message file.
+#
+# To enable this hook, rename this file to "commit-msg".
+
+# Uncomment the below to add a Signed-off-by line to the message.
+# Doing this in a hook is a bad idea in general, but the prepare-commit-msg
+# hook is more suited to it.
+#
+# SOB=$(git var GIT_AUTHOR_IDENT | sed -n 's/^\(.*>\).*$/Signed-off-by: \1/p')
+# grep -qs "^$SOB" "$1" || echo "$SOB" >> "$1"
+
+# This example catches duplicate Signed-off-by lines.
+
+test "" = "$(grep '^Signed-off-by: ' "$1" |
+	 sort | uniq -c | sed -e '/^[ 	]*1[ 	]/d')" || {
+	echo >&2 Duplicate Signed-off-by lines.
+	exit 1
+}

http://git-wip-us.apache.org/repos/asf/incubator-allura/blob/bb12ad35/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/post-commit.sample
----------------------------------------------------------------------
diff --git a/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/post-commit.sample b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/post-commit.sample
new file mode 100755
index 0000000..2266821
--- /dev/null
+++ b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/post-commit.sample
@@ -0,0 +1,8 @@
+#!/bin/sh
+#
+# An example hook script that is called after a successful
+# commit is made.
+#
+# To enable this hook, rename this file to "post-commit".
+
+: Nothing

http://git-wip-us.apache.org/repos/asf/incubator-allura/blob/bb12ad35/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/post-receive
----------------------------------------------------------------------
diff --git a/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/post-receive b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/post-receive
new file mode 100755
index 0000000..0f7a148
--- /dev/null
+++ b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/post-receive
@@ -0,0 +1 @@
+post-receive

http://git-wip-us.apache.org/repos/asf/incubator-allura/blob/bb12ad35/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/post-receive.sample
----------------------------------------------------------------------
diff --git a/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/post-receive.sample b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/post-receive.sample
new file mode 100755
index 0000000..7a83e17
--- /dev/null
+++ b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/post-receive.sample
@@ -0,0 +1,15 @@
+#!/bin/sh
+#
+# An example hook script for the "post-receive" event.
+#
+# The "post-receive" script is run after receive-pack has accepted a pack
+# and the repository has been updated.  It is passed arguments in through
+# stdin in the form
+#  <oldrev> <newrev> <refname>
+# For example:
+#  aa453216d1b3e49e7f6f98441fa56946ddcd6a20 68f7abf4e6f922807889f52bc043ecd31b79f814 refs/heads/master
+#
+# see contrib/hooks/ for a sample, or uncomment the next line and
+# rename the file to "post-receive".
+
+#. /usr/share/doc/git-core/contrib/hooks/post-receive-email

http://git-wip-us.apache.org/repos/asf/incubator-allura/blob/bb12ad35/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/post-update.sample
----------------------------------------------------------------------
diff --git a/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/post-update.sample b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/post-update.sample
new file mode 100755
index 0000000..5323b56
--- /dev/null
+++ b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/post-update.sample
@@ -0,0 +1,8 @@
+#!/bin/sh
+#
+# An example hook script to prepare a packed repository for use over
+# dumb transports.
+#
+# To enable this hook, rename this file to "post-update".
+
+exec git-update-server-info

http://git-wip-us.apache.org/repos/asf/incubator-allura/blob/bb12ad35/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/pre-applypatch.sample
----------------------------------------------------------------------
diff --git a/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/pre-applypatch.sample b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/pre-applypatch.sample
new file mode 100755
index 0000000..b1f187c
--- /dev/null
+++ b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/pre-applypatch.sample
@@ -0,0 +1,14 @@
+#!/bin/sh
+#
+# An example hook script to verify what is about to be committed
+# by applypatch from an e-mail message.
+#
+# The hook should exit with non-zero status after issuing an
+# appropriate message if it wants to stop the commit.
+#
+# To enable this hook, rename this file to "pre-applypatch".
+
+. git-sh-setup
+test -x "$GIT_DIR/hooks/pre-commit" &&
+	exec "$GIT_DIR/hooks/pre-commit" ${1+"$@"}
+:

http://git-wip-us.apache.org/repos/asf/incubator-allura/blob/bb12ad35/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/pre-commit.sample
----------------------------------------------------------------------
diff --git a/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/pre-commit.sample b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/pre-commit.sample
new file mode 100755
index 0000000..439eefd
--- /dev/null
+++ b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/pre-commit.sample
@@ -0,0 +1,46 @@
+#!/bin/sh
+#
+# An example hook script to verify what is about to be committed.
+# Called by git-commit with no arguments.  The hook should
+# exit with non-zero status after issuing an appropriate message if
+# it wants to stop the commit.
+#
+# To enable this hook, rename this file to "pre-commit".
+
+if git-rev-parse --verify HEAD >/dev/null 2>&1
+then
+	against=HEAD
+else
+	# Initial commit: diff against an empty tree object
+	against=4b825dc642cb6eb9a060e54bf8d69288fbee4904
+fi
+
+# If you want to allow non-ascii filenames set this variable to true.
+allownonascii=$(git config hooks.allownonascii)
+
+# Cross platform projects tend to avoid non-ascii filenames; prevent
+# them from being added to the repository. We exploit the fact that the
+# printable range starts at the space character and ends with tilde.
+if [ "$allownonascii" != "true" ] &&
+	# Note that the use of brackets around a tr range is ok here, (it's
+	# even required, for portability to Solaris 10's /usr/bin/tr), since
+	# the square bracket bytes happen to fall in the designated range.
+	test "$(git diff --cached --name-only --diff-filter=A -z $against |
+	  LC_ALL=C tr -d '[ -~]\0')"
+then
+	echo "Error: Attempt to add a non-ascii file name."
+	echo
+	echo "This can cause problems if you want to work"
+	echo "with people on other platforms."
+	echo
+	echo "To be portable it is advisable to rename the file ..."
+	echo
+	echo "If you know what you are doing you can disable this"
+	echo "check using:"
+	echo
+	echo "  git config hooks.allownonascii true"
+	echo
+	exit 1
+fi
+
+exec git diff-index --check --cached $against --

http://git-wip-us.apache.org/repos/asf/incubator-allura/blob/bb12ad35/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/pre-rebase.sample
----------------------------------------------------------------------
diff --git a/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/pre-rebase.sample b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/pre-rebase.sample
new file mode 100755
index 0000000..be1b06e
--- /dev/null
+++ b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/pre-rebase.sample
@@ -0,0 +1,169 @@
+#!/bin/sh
+#
+# Copyright (c) 2006, 2008 Junio C Hamano
+#
+# The "pre-rebase" hook is run just before "git-rebase" starts doing
+# its job, and can prevent the command from running by exiting with
+# non-zero status.
+#
+# The hook is called with the following parameters:
+#
+# $1 -- the upstream the series was forked from.
+# $2 -- the branch being rebased (or empty when rebasing the current branch).
+#
+# This sample shows how to prevent topic branches that are already
+# merged to 'next' branch from getting rebased, because allowing it
+# would result in rebasing already published history.
+
+publish=next
+basebranch="$1"
+if test "$#" = 2
+then
+	topic="refs/heads/$2"
+else
+	topic=`git symbolic-ref HEAD` ||
+	exit 0 ;# we do not interrupt rebasing detached HEAD
+fi
+
+case "$topic" in
+refs/heads/??/*)
+	;;
+*)
+	exit 0 ;# we do not interrupt others.
+	;;
+esac
+
+# Now we are dealing with a topic branch being rebased
+# on top of master.  Is it OK to rebase it?
+
+# Does the topic really exist?
+git show-ref -q "$topic" || {
+	echo >&2 "No such branch $topic"
+	exit 1
+}
+
+# Is topic fully merged to master?
+not_in_master=`git-rev-list --pretty=oneline ^master "$topic"`
+if test -z "$not_in_master"
+then
+	echo >&2 "$topic is fully merged to master; better remove it."
+	exit 1 ;# we could allow it, but there is no point.
+fi
+
+# Is topic ever merged to next?  If so you should not be rebasing it.
+only_next_1=`git-rev-list ^master "^$topic" ${publish} | sort`
+only_next_2=`git-rev-list ^master           ${publish} | sort`
+if test "$only_next_1" = "$only_next_2"
+then
+	not_in_topic=`git-rev-list "^$topic" master`
+	if test -z "$not_in_topic"
+	then
+		echo >&2 "$topic is already up-to-date with master"
+		exit 1 ;# we could allow it, but there is no point.
+	else
+		exit 0
+	fi
+else
+	not_in_next=`git-rev-list --pretty=oneline ^${publish} "$topic"`
+	perl -e '
+		my $topic = $ARGV[0];
+		my $msg = "* $topic has commits already merged to public branch:\n";
+		my (%not_in_next) = map {
+			/^([0-9a-f]+) /;
+			($1 => 1);
+		} split(/\n/, $ARGV[1]);
+		for my $elem (map {
+				/^([0-9a-f]+) (.*)$/;
+				[$1 => $2];
+			} split(/\n/, $ARGV[2])) {
+			if (!exists $not_in_next{$elem->[0]}) {
+				if ($msg) {
+					print STDERR $msg;
+					undef $msg;
+				}
+				print STDERR " $elem->[1]\n";
+			}
+		}
+	' "$topic" "$not_in_next" "$not_in_master"
+	exit 1
+fi
+
+exit 0
+
+################################################################
+
+This sample hook safeguards topic branches that have been
+published from being rewound.
+
+The workflow assumed here is:
+
+ * Once a topic branch forks from "master", "master" is never
+   merged into it again (either directly or indirectly).
+
+ * Once a topic branch is fully cooked and merged into "master",
+   it is deleted.  If you need to build on top of it to correct
+   earlier mistakes, a new topic branch is created by forking at
+   the tip of the "master".  This is not strictly necessary, but
+   it makes it easier to keep your history simple.
+
+ * Whenever you need to test or publish your changes to topic
+   branches, merge them into "next" branch.
+
+The script, being an example, hardcodes the publish branch name
+to be "next", but it is trivial to make it configurable via
+$GIT_DIR/config mechanism.
+
+With this workflow, you would want to know:
+
+(1) ... if a topic branch has ever been merged to "next".  Young
+    topic branches can have stupid mistakes you would rather
+    clean up before publishing, and things that have not been
+    merged into other branches can be easily rebased without
+    affecting other people.  But once it is published, you would
+    not want to rewind it.
+
+(2) ... if a topic branch has been fully merged to "master".
+    Then you can delete it.  More importantly, you should not
+    build on top of it -- other people may already want to
+    change things related to the topic as patches against your
+    "master", so if you need further changes, it is better to
+    fork the topic (perhaps with the same name) afresh from the
+    tip of "master".
+
+Let's look at this example:
+
+		   o---o---o---o---o---o---o---o---o---o "next"
+		  /       /           /           /
+		 /   a---a---b A     /           /
+		/   /               /           /
+	       /   /   c---c---c---c B         /
+	      /   /   /             \         /
+	     /   /   /   b---b C     \       /
+	    /   /   /   /             \     /
+    ---o---o---o---o---o---o---o---o---o---o---o "master"
+
+
+A, B and C are topic branches.
+
+ * A has one fix since it was merged up to "next".
+
+ * B has finished.  It has been fully merged up to "master" and "next",
+   and is ready to be deleted.
+
+ * C has not merged to "next" at all.
+
+We would want to allow C to be rebased, refuse A, and encourage
+B to be deleted.
+
+To compute (1):
+
+	git-rev-list ^master ^topic next
+	git-rev-list ^master        next
+
+	if these match, topic has not merged in next at all.
+
+To compute (2):
+
+	git-rev-list master..topic
+
+	if this is empty, it is fully merged to "master".

http://git-wip-us.apache.org/repos/asf/incubator-allura/blob/bb12ad35/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/prepare-commit-msg.sample
----------------------------------------------------------------------
diff --git a/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/prepare-commit-msg.sample b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/prepare-commit-msg.sample
new file mode 100755
index 0000000..3652424
--- /dev/null
+++ b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/prepare-commit-msg.sample
@@ -0,0 +1,36 @@
+#!/bin/sh
+#
+# An example hook script to prepare the commit log message.
+# Called by git-commit with the name of the file that has the
+# commit message, followed by the description of the commit
+# message's source.  The hook's purpose is to edit the commit
+# message file.  If the hook fails with a non-zero status,
+# the commit is aborted.
+#
+# To enable this hook, rename this file to "prepare-commit-msg".
+
+# This hook includes three examples.  The first comments out the
+# "Conflicts:" part of a merge commit.
+#
+# The second includes the output of "git diff --name-status -r"
+# into the message, just before the "git status" output.  It is
+# commented because it doesn't cope with --amend or with squashed
+# commits.
+#
+# The third example adds a Signed-off-by line to the message, that can
+# still be edited.  This is rarely a good idea.
+
+case "$2,$3" in
+  merge,)
+    perl -i.bak -ne 's/^/# /, s/^# #/#/ if /^Conflicts/ .. /#/; print' "$1" ;;
+
+# ,|template,)
+#   perl -i.bak -pe '
+#      print "\n" . `git diff --cached --name-status -r`
+#	 if /^#/ && $first++ == 0' "$1" ;;
+
+  *) ;;
+esac
+
+# SOB=$(git var GIT_AUTHOR_IDENT | sed -n 's/^\(.*>\).*$/Signed-off-by: \1/p')
+# grep -qs "^$SOB" "$1" || echo "$SOB" >> "$1"

http://git-wip-us.apache.org/repos/asf/incubator-allura/blob/bb12ad35/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/update
----------------------------------------------------------------------
diff --git a/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/update b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/update
new file mode 100755
index 0000000..4ea5e4d
--- /dev/null
+++ b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/update
@@ -0,0 +1 @@
+update

http://git-wip-us.apache.org/repos/asf/incubator-allura/blob/bb12ad35/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/update.sample
----------------------------------------------------------------------
diff --git a/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/update.sample b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/update.sample
new file mode 100755
index 0000000..fd63b2d
--- /dev/null
+++ b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/hooks/update.sample
@@ -0,0 +1,128 @@
+#!/bin/sh
+#
+# An example hook script to blocks unannotated tags from entering.
+# Called by git-receive-pack with arguments: refname sha1-old sha1-new
+#
+# To enable this hook, rename this file to "update".
+#
+# Config
+# ------
+# hooks.allowunannotated
+#   This boolean sets whether unannotated tags will be allowed into the
+#   repository.  By default they won't be.
+# hooks.allowdeletetag
+#   This boolean sets whether deleting tags will be allowed in the
+#   repository.  By default they won't be.
+# hooks.allowmodifytag
+#   This boolean sets whether a tag may be modified after creation. By default
+#   it won't be.
+# hooks.allowdeletebranch
+#   This boolean sets whether deleting branches will be allowed in the
+#   repository.  By default they won't be.
+# hooks.denycreatebranch
+#   This boolean sets whether remotely creating branches will be denied
+#   in the repository.  By default this is allowed.
+#
+
+# --- Command line
+refname="$1"
+oldrev="$2"
+newrev="$3"
+
+# --- Safety check
+if [ -z "$GIT_DIR" ]; then
+	echo "Don't run this script from the command line." >&2
+	echo " (if you want, you could supply GIT_DIR then run" >&2
+	echo "  $0 <ref> <oldrev> <newrev>)" >&2
+	exit 1
+fi
+
+if [ -z "$refname" -o -z "$oldrev" -o -z "$newrev" ]; then
+	echo "Usage: $0 <ref> <oldrev> <newrev>" >&2
+	exit 1
+fi
+
+# --- Config
+allowunannotated=$(git config --bool hooks.allowunannotated)
+allowdeletebranch=$(git config --bool hooks.allowdeletebranch)
+denycreatebranch=$(git config --bool hooks.denycreatebranch)
+allowdeletetag=$(git config --bool hooks.allowdeletetag)
+allowmodifytag=$(git config --bool hooks.allowmodifytag)
+
+# check for no description
+projectdesc=$(sed -e '1q' "$GIT_DIR/description")
+case "$projectdesc" in
+"Unnamed repository"* | "")
+	echo "*** Project description file hasn't been set" >&2
+	exit 1
+	;;
+esac
+
+# --- Check types
+# if $newrev is 0000...0000, it's a commit to delete a ref.
+zero="0000000000000000000000000000000000000000"
+if [ "$newrev" = "$zero" ]; then
+	newrev_type=delete
+else
+	newrev_type=$(git-cat-file -t $newrev)
+fi
+
+case "$refname","$newrev_type" in
+	refs/tags/*,commit)
+		# un-annotated tag
+		short_refname=${refname##refs/tags/}
+		if [ "$allowunannotated" != "true" ]; then
+			echo "*** The un-annotated tag, $short_refname, is not allowed in this repository" >&2
+			echo "*** Use 'git tag [ -a | -s ]' for tags you want to propagate." >&2
+			exit 1
+		fi
+		;;
+	refs/tags/*,delete)
+		# delete tag
+		if [ "$allowdeletetag" != "true" ]; then
+			echo "*** Deleting a tag is not allowed in this repository" >&2
+			exit 1
+		fi
+		;;
+	refs/tags/*,tag)
+		# annotated tag
+		if [ "$allowmodifytag" != "true" ] && git rev-parse $refname > /dev/null 2>&1
+		then
+			echo "*** Tag '$refname' already exists." >&2
+			echo "*** Modifying a tag is not allowed in this repository." >&2
+			exit 1
+		fi
+		;;
+	refs/heads/*,commit)
+		# branch
+		if [ "$oldrev" = "$zero" -a "$denycreatebranch" = "true" ]; then
+			echo "*** Creating a branch is not allowed in this repository" >&2
+			exit 1
+		fi
+		;;
+	refs/heads/*,delete)
+		# delete branch
+		if [ "$allowdeletebranch" != "true" ]; then
+			echo "*** Deleting a branch is not allowed in this repository" >&2
+			exit 1
+		fi
+		;;
+	refs/remotes/*,commit)
+		# tracking branch
+		;;
+	refs/remotes/*,delete)
+		# delete tracking branch
+		if [ "$allowdeletebranch" != "true" ]; then
+			echo "*** Deleting a tracking branch is not allowed in this repository" >&2
+			exit 1
+		fi
+		;;
+	*)
+		# Anything else (is there anything else?)
+		echo "*** Update hook: unknown type of update to ref $refname of type $newrev_type" >&2
+		exit 1
+		;;
+esac
+
+# --- Finished
+exit 0

http://git-wip-us.apache.org/repos/asf/incubator-allura/blob/bb12ad35/ForgeUserStats/forgeuserstats/tests/data/testgit.git/info/exclude
----------------------------------------------------------------------
diff --git a/ForgeUserStats/forgeuserstats/tests/data/testgit.git/info/exclude b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/info/exclude
new file mode 100644
index 0000000..2c87b72
--- /dev/null
+++ b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/info/exclude
@@ -0,0 +1,6 @@
+# git-ls-files --others --exclude-from=.git/info/exclude
+# Lines that start with '#' are comments.
+# For a project mostly in C, the following would be a good set of
+# exclude patterns (uncomment them if you want to use them):
+# *.[oa]
+# *~

http://git-wip-us.apache.org/repos/asf/incubator-allura/blob/bb12ad35/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/0d/666fc313e6f4829e8d4446d4529394f8e464a9
----------------------------------------------------------------------
diff --git a/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/0d/666fc313e6f4829e8d4446d4529394f8e464a9 b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/0d/666fc313e6f4829e8d4446d4529394f8e464a9
new file mode 100644
index 0000000..934760d
Binary files /dev/null and b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/0d/666fc313e6f4829e8d4446d4529394f8e464a9 differ

http://git-wip-us.apache.org/repos/asf/incubator-allura/blob/bb12ad35/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/0f/419b54b956f4a849a689105216282f1a4c749a
----------------------------------------------------------------------
diff --git a/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/0f/419b54b956f4a849a689105216282f1a4c749a b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/0f/419b54b956f4a849a689105216282f1a4c749a
new file mode 100644
index 0000000..a7d3884
Binary files /dev/null and b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/0f/419b54b956f4a849a689105216282f1a4c749a differ

http://git-wip-us.apache.org/repos/asf/incubator-allura/blob/bb12ad35/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/1e/146e67985dcd71c74de79613719bef7bddca4a
----------------------------------------------------------------------
diff --git a/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/1e/146e67985dcd71c74de79613719bef7bddca4a b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/1e/146e67985dcd71c74de79613719bef7bddca4a
new file mode 100644
index 0000000..2f0027a
Binary files /dev/null and b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/1e/146e67985dcd71c74de79613719bef7bddca4a differ

http://git-wip-us.apache.org/repos/asf/incubator-allura/blob/bb12ad35/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/43/80f66cf5cbd858b73156681d665593ec80a58d
----------------------------------------------------------------------
diff --git a/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/43/80f66cf5cbd858b73156681d665593ec80a58d b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/43/80f66cf5cbd858b73156681d665593ec80a58d
new file mode 100644
index 0000000..fe031e3
Binary files /dev/null and b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/43/80f66cf5cbd858b73156681d665593ec80a58d differ

http://git-wip-us.apache.org/repos/asf/incubator-allura/blob/bb12ad35/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/4b/825dc642cb6eb9a060e54bf8d69288fbee4904
----------------------------------------------------------------------
diff --git a/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/4b/825dc642cb6eb9a060e54bf8d69288fbee4904 b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/4b/825dc642cb6eb9a060e54bf8d69288fbee4904
new file mode 100644
index 0000000..adf6411
Binary files /dev/null and b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/4b/825dc642cb6eb9a060e54bf8d69288fbee4904 differ

http://git-wip-us.apache.org/repos/asf/incubator-allura/blob/bb12ad35/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/6a/45885ae7347f1cac5103b0050cc1be6a1496c8
----------------------------------------------------------------------
diff --git a/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/6a/45885ae7347f1cac5103b0050cc1be6a1496c8 b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/6a/45885ae7347f1cac5103b0050cc1be6a1496c8
new file mode 100644
index 0000000..42efcfb
Binary files /dev/null and b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/6a/45885ae7347f1cac5103b0050cc1be6a1496c8 differ

http://git-wip-us.apache.org/repos/asf/incubator-allura/blob/bb12ad35/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/6d/2ce67bdd55ae2c2ac72cbc879ed7c67ecc9786
----------------------------------------------------------------------
diff --git a/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/6d/2ce67bdd55ae2c2ac72cbc879ed7c67ecc9786 b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/6d/2ce67bdd55ae2c2ac72cbc879ed7c67ecc9786
new file mode 100644
index 0000000..838b73a
Binary files /dev/null and b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/6d/2ce67bdd55ae2c2ac72cbc879ed7c67ecc9786 differ

http://git-wip-us.apache.org/repos/asf/incubator-allura/blob/bb12ad35/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/8c/3c7fbcd903744b20fd7567a1fcefa99133b5bc
----------------------------------------------------------------------
diff --git a/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/8c/3c7fbcd903744b20fd7567a1fcefa99133b5bc b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/8c/3c7fbcd903744b20fd7567a1fcefa99133b5bc
new file mode 100644
index 0000000..7c9f6bb
Binary files /dev/null and b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/8c/3c7fbcd903744b20fd7567a1fcefa99133b5bc differ

http://git-wip-us.apache.org/repos/asf/incubator-allura/blob/bb12ad35/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/9a/7df788cf800241e3bb5a849c8870f2f8259d98
----------------------------------------------------------------------
diff --git a/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/9a/7df788cf800241e3bb5a849c8870f2f8259d98 b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/9a/7df788cf800241e3bb5a849c8870f2f8259d98
new file mode 100644
index 0000000..04693ec
Binary files /dev/null and b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/9a/7df788cf800241e3bb5a849c8870f2f8259d98 differ

http://git-wip-us.apache.org/repos/asf/incubator-allura/blob/bb12ad35/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/be/00c63250248c284b842deee5d8fb0b8132acab
----------------------------------------------------------------------
diff --git a/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/be/00c63250248c284b842deee5d8fb0b8132acab b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/be/00c63250248c284b842deee5d8fb0b8132acab
new file mode 100644
index 0000000..2cab292
Binary files /dev/null and b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/be/00c63250248c284b842deee5d8fb0b8132acab differ

http://git-wip-us.apache.org/repos/asf/incubator-allura/blob/bb12ad35/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/d7/c40db3ffe2b87e96b94c280a67265c8de7a4ad
----------------------------------------------------------------------
diff --git a/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/d7/c40db3ffe2b87e96b94c280a67265c8de7a4ad b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/d7/c40db3ffe2b87e96b94c280a67265c8de7a4ad
new file mode 100644
index 0000000..491fcfa
Binary files /dev/null and b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/d7/c40db3ffe2b87e96b94c280a67265c8de7a4ad differ

http://git-wip-us.apache.org/repos/asf/incubator-allura/blob/bb12ad35/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/df/30427c488aeab84b2352bdf88a3b19223f9d7a
----------------------------------------------------------------------
diff --git a/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/df/30427c488aeab84b2352bdf88a3b19223f9d7a b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/df/30427c488aeab84b2352bdf88a3b19223f9d7a
new file mode 100644
index 0000000..8ad2f5e
--- /dev/null
+++ b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/df/30427c488aeab84b2352bdf88a3b19223f9d7a
@@ -0,0 +1,2 @@
+x��K
+�@@]�)r%�f~ ��K7� MSm+e��"��������0�*x�u6�J�-!�,���\����IX�G���6V��!� �N=�h lZĀ��Z�5;y��4���w�OO{���z�n/f��hu�s䔐	�ȈN�����ݮ��|�NG�c�E�
\ No newline at end of file

http://git-wip-us.apache.org/repos/asf/incubator-allura/blob/bb12ad35/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/e5/6a4d15295d3754310f114c86d93645308110ad
----------------------------------------------------------------------
diff --git a/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/e5/6a4d15295d3754310f114c86d93645308110ad b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/e5/6a4d15295d3754310f114c86d93645308110ad
new file mode 100644
index 0000000..7d5ae85
Binary files /dev/null and b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/e5/6a4d15295d3754310f114c86d93645308110ad differ

http://git-wip-us.apache.org/repos/asf/incubator-allura/blob/bb12ad35/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/e9/65047ad7c57865823c7d992b1d046ea66edf78
----------------------------------------------------------------------
diff --git a/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/e9/65047ad7c57865823c7d992b1d046ea66edf78 b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/e9/65047ad7c57865823c7d992b1d046ea66edf78
new file mode 100644
index 0000000..341688a
Binary files /dev/null and b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/objects/e9/65047ad7c57865823c7d992b1d046ea66edf78 differ

http://git-wip-us.apache.org/repos/asf/incubator-allura/blob/bb12ad35/ForgeUserStats/forgeuserstats/tests/data/testgit.git/refs/heads/master
----------------------------------------------------------------------
diff --git a/ForgeUserStats/forgeuserstats/tests/data/testgit.git/refs/heads/master b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/refs/heads/master
new file mode 100644
index 0000000..7e970a5
--- /dev/null
+++ b/ForgeUserStats/forgeuserstats/tests/data/testgit.git/refs/heads/master
@@ -0,0 +1 @@
+1e146e67985dcd71c74de79613719bef7bddca4a

http://git-wip-us.apache.org/repos/asf/incubator-allura/blob/bb12ad35/ForgeUserStats/forgeuserstats/tests/test_stats.py
----------------------------------------------------------------------
diff --git a/ForgeUserStats/forgeuserstats/tests/test_stats.py b/ForgeUserStats/forgeuserstats/tests/test_stats.py
index f0ee6a2..2972a0e 100644
--- a/ForgeUserStats/forgeuserstats/tests/test_stats.py
+++ b/ForgeUserStats/forgeuserstats/tests/test_stats.py
@@ -1,13 +1,16 @@
 import pkg_resources
+import unittest
 
 from pylons import app_globals as g
 from pylons import tmpl_context as c
 
-from alluratest.controller import TestController
+from alluratest.controller import TestController, setup_basic_test, setup_global_objects
 from allura.tests import decorators as td
 from allura.lib import helpers as h
 from allura.model import User
+from allura import model as M
 
+from forgegit.tests import with_git
 from forgewiki import model as WM
 from forgetracker import model as TM
 
@@ -171,3 +174,40 @@ class TestStats(TestController):
         assert tickets['revoked'] == initial_tickets['revoked'] + 1
         assert tickets_artifacts['created'] == initial_tickets_artifacts['created'] + 2
         assert tickets_artifacts['modified'] == initial_tickets_artifacts['modified'] + 3
+
+class TestGitCommit(unittest.TestCase, TestController):
+
+    def setUp(self):
+        setup_basic_test()
+        for ep in pkg_resources.iter_entry_points("allura.stats"):
+            if ep.name.lower() == 'userstats':
+                g.statslisteners = [ep.load()().listener]
+
+        self.user = User.register(dict(username='testuser',
+            display_name='Test'),
+            make_project=False)
+        self.user.set_password('testpassword')
+        addr = M.EmailAddress.upsert('rcopeland@geek.net')
+        self.user.claim_address('rcopeland@geek.net')
+        self.setup_with_tools()
+
+    @with_git
+    @td.with_wiki
+    def setup_with_tools(self):
+        setup_global_objects()
+        h.set_context('test', 'src-git', neighborhood='Projects')
+        repo_dir = pkg_resources.resource_filename(
+            'forgeuserstats', 'tests/data')
+        c.app.repo.fs_path = repo_dir
+        c.app.repo.name = 'testgit.git'
+        self.repo = c.app.repo
+        self.repo.refresh()
+        self.rev = M.repo.Commit.query.get(_id=self.repo.heads[0]['object_id'])
+        self.rev.repo = self.repo
+
+    def test_commit(self):
+        commits = self.user.stats.getCommits()
+        assert commits['number'] == 4
+        lmcommits = self.user.stats.getLastMonthCommits()
+        assert lmcommits['number'] == 4
+

http://git-wip-us.apache.org/repos/asf/incubator-allura/blob/bb12ad35/ForgeUserStats/test.ini
----------------------------------------------------------------------
diff --git a/ForgeUserStats/test.ini b/ForgeUserStats/test.ini
new file mode 100644
index 0000000..6753aa4
--- /dev/null
+++ b/ForgeUserStats/test.ini
@@ -0,0 +1,54 @@
+#
+# allura - TurboGears 2 testing environment configuration
+#
+# The %(here)s variable will be replaced with the parent directory of this file
+#
+[DEFAULT]
+debug = true
+
+[server:main]
+use = egg:Paste#http
+host = 0.0.0.0
+port = 5000
+
+[app:main]
+use = config:../Allura/test.ini
+
+[app:main_without_authn]
+use = config:../Allura/test.ini#main_without_authn
+
+[app:main_with_amqp]
+use = config:../Allura/test.ini#main_with_amqp
+
+[loggers]
+keys = root, allura, tool
+
+[handlers]
+keys = test
+
+[formatters]
+keys = generic
+
+[logger_root]
+level = INFO
+handlers = test
+
+[logger_allura]
+level = DEBUG
+handlers =
+qualname = allura
+
+[logger_tool]
+level = DEBUG
+handlers =
+qualname = forgeuserstats
+
+[handler_test]
+class = FileHandler
+args = ('test.log',)
+level = NOTSET
+formatter = generic
+
+[formatter_generic]
+format = %(asctime)s,%(msecs)03d %(levelname)-5.5s [%(name)s] %(message)s
+datefmt = %H:%M:%S